<?php 

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use \Doctrine\ORM\EntityManager;


class CancelamentoServico {
    
	protected $entityManager; 

	public function __construct(EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

    private function setReportParameters(&$params, &$conditions) {
        $params = array(
            ':DATAINI' => isset($conditions['DATAINI']) ? $conditions['DATAINI'] : null ,
            ':DATAFIN' => isset($conditions['DATAFIN']) ? $conditions['DATAFIN'] : null ,
            // ':CDFILIAL' => isset($conditions['CDFILIAL']) ? $conditions['CDFILIAL'] : null ,
            // ':CDLOJA' => isset($conditions['CDLOJA']) ? $conditions['CDLOJA'] : null ,
            ':TCDLOJA' => isset($conditions['TCDLOJA']) ? $conditions['TCDLOJA'] : null ,
            // ':CDVENDEDOR' => isset($conditions['CDVENDEDOR']) ? $conditions['CDVENDEDOR'] : null ,
            ':TCDVENDEDOR' => (isset($conditions['TCDVENDEDOR']) ? $conditions['TCDVENDEDOR'] : (isset($conditions['CDVENDEDOR']) ? ($conditions['CDVENDEDOR'] == null ? 'T' : 'F') : 'T')),
            ':NRORG' => $conditions['NRORG']
        );
    }

    private function sanitizeFilter($param) {

        $property = preg_replace('/(^_+|_+$)/', '', $param);
        $property = preg_replace('/_+/', "', '", $property);
        $property = "'" . $property . "'";

        return $property;
    }
    
    public function getCancelamentoServico($conditions) {
    	$params = [];
        $this->setReportParameters($params, $conditions);
        $CDFILIAL = $this->sanitizeFilter($conditions['CDFILIAL']);
        $CDLOJA = $this->sanitizeFilter(isset($conditions['CDLOJA']) ? $conditions['CDLOJA'] : "");
        $CDVENDEDOR = $this->sanitizeFilter(isset($conditions['CDVENDEDOR']) ? $conditions['CDVENDEDOR'] : "");

        $REL_CANCELAMENTO_SERVICO_ACRESCIMO = "
        SELECT LABELFILIAL, GARCON, CDLOJA, CDFILIAL, CDCAIXA, NRSEQVENDA, VRCOMISVENDA, DTENTRVENDA, NRMESA, CDVENDEDOR,
              CDSUPERVISOR, VRTOTPROD, VRGORJETA, VRTOTGOR, DESCGORJ, NRORG, CDFAMILISALD, PERCENT, NRINSJURVEN, OPERADOR
            FROM
            (
                SELECT FLC.CDFILIAL ||' - ' ||FLC.NMFILIAL||' - Loja: ' ||FLC.CDLOJA ||' - ' ||FLC.NMLOJA AS LABELFILIAL, V.NRSEQVENDA, V.CDFILIAL, VE.IDVRINCIDECONTA,
                    DECODE (V.CDVENDEDOR ||' - ' ||VE.NMRAZSOCVEN, ' ', 'Venda Sem Garçon', V.CDVENDEDOR ||' ' ||VE.NMRAZSOCVEN) AS GARCON, V.NRORG, L.CDCAIXA, VE.VRPERCCOMISVEND, 
                    L.CDOPERCAIXA||' - '||L.NMOPERCAIXA AS OPERADOR, L.CDOPERRESPOP||' - '||L.NMOPERRESPOP AS CDSUPERVISOR, LJ.VRCOMISVENDA, V.DTENTRVENDA, 'N° Mesa: '||V.NRMESA||' - N° Venda: '|| V.NRSEQVENDA AS NRMESA, V.CDVENDEDOR, 
                    L.DTHROPERFOS, REPLACE(V.NRCOMANDAVND, '_', '') NRCOMANDAVND, VE.NRINSJURVEN, LJ.IDCOMISVENDA, SUM(NVL(ITV.VRACRITVEND,0)) AS VRGORJETA,
                    SUM ((ITV.QTPRODVEND * (ITV.VRUNITVEND))- ITV.VRDESITVEND) AS VRTOTPROD, FLC.CDLOJA, ITV.CDFAMILISALD,
                    TRUNC((SUM (((ITV.QTPRODVEND * (ITV.VRUNITVEND))- ITV.VRDESITVEND) * (LJ.VRCOMISVENDA/100))) - SUM(ITV.VRACRITVEND),2) AS DESCGORJ,
                    TRUNC(SUM (((ITV.QTPRODVEND * (ITV.VRUNITVEND)) - ITV.VRDESITVEND) * (DECODE (LJ.IDCOMISVENDA, 'S', LJ.VRCOMISVENDA, 'G', DECODE(VE.IDVRINCIDECONTA, 'S', VE.VRPERCCOMISVEND, 0))/100)), 2) AS VRTOTGOR,
                    TRUNC(((SUM(NVL(ITV.VRACRITVEND,0))/NVL(SUM ((ITV.QTPRODVEND * (ITV.VRUNITVEND)) - ITV.VRDESITVEND), 1))*100),2) AS PERCENT
                FROM LOGOPERFOS L, VENDA V, V_FILIALLOJACAIXA FLC, VENDEDOR VE, LOJA LJ, ITEMVENDA ITV
                    WHERE L.IDOPERFOS = 'RET_TAX'
                        AND V.CDFILIAL = L.CDFILIAL
                        AND V.CDVENDEDOR = VE.CDVENDEDOR
                        AND V.NRORG = VE.NRORG
                        AND V.CDFILIAL = LJ.CDFILIAL
                        AND V.CDLOJA = LJ.CDLOJA
                        AND FLC.CDFILIAL = LJ.CDFILIAL
                        AND V.NRORG = LJ.NRORG
                        AND V.CDCAIXA = L.CDCAIXA
                        AND V.NRMESA = SUBSTR(DSLIVREFOS, INSTR(DSLIVREFOS,':')+2,4)
                        AND V.CDFILIAL = FLC.CDFILIAL
                        AND V.CDCAIXA = FLC.CDCAIXA
                        AND V.CDLOJA = FLC.CDLOJA
                        AND TRIM(REPLACE(V.NRCOMANDAVND,'_',' ')) = SUBSTR(DSLIVREFOS, INSTR(DSLIVREFOS,'/0') + 1, 10)
                        AND TRUNC(DTHROPERFOS) BETWEEN :DATAINI AND :DATAFIN
                        AND V.CDFILIAL = ITV.CDFILIAL
                        AND V.CDCAIXA = ITV.CDCAIXA
                        AND V.NRSEQVENDA = ITV.NRSEQVENDA
                        AND FLC.CDFILIAL IN (".$CDFILIAL.") 
                        AND ((:TCDLOJA = 'T') OR (FLC.CDFILIAL || FLC.CDLOJA IN (".$CDLOJA.")) OR (FLC.CDLOJA IN (".$CDLOJA.")))
                        AND ((:TCDVENDEDOR = 'T') OR (NVL(ITV.CDVENDEDOR,V.CDVENDEDOR) IN (".$CDVENDEDOR.")))
                        AND V.NRORG = ITV.NRORG
                        AND V.NRORG = :NRORG
                    GROUP BY FLC.CDFILIAL, FLC.CDLOJA, FLC.NMFILIAL, FLC.NMLOJA, V.NRSEQVENDA, V.CDSUPERVISOR, V.NRMESA, V.DTENTRVENDA, V.CDVENDEDOR, VE.VRPERCCOMISVEND, FLC.CDLOJA, L.DTHROPERFOS, LJ.IDCOMISVENDA, 
                        V.CDFILIAL, L.CDCAIXA, LJ.VRCOMISVENDA, V.NRORG, VE.NMRAZSOCVEN, VE.IDVRINCIDECONTA, VE.NRINSJURVEN, L.CDOPERCAIXA, L.NMOPERCAIXA, L.CDOPERRESPOP, L.NMOPERRESPOP, V.NRCOMANDAVND, ITV.CDFAMILISALD
            )
        ";

        return $this->entityManager->getConnection()->fetchAll($REL_CANCELAMENTO_SERVICO_ACRESCIMO, $params);
    }
    
}